###############################################################################
# Recent.pl                                                                   #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Software Version: YaBB 1 Gold - SP1                                         #
# Released: December 2001                                                     #
# =========================================================================== #
# Software Distributed by:    http://yabb.xnull.com                           #
# Support, News, Updates at:  http://yabb.xnull.com/community/                #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$recentplver = "1 Gold - SP1";

sub TotalToday {
	( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	$numfound=0;

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	($newsecond,$newminute,$newhour,$newday,$newmonth,$newyear,$wday,$yday,$isdst) = localtime(time + (3600*$timeoffset));
	$newmonth = $newmonth+1;
	$newhour = "0$newhour" if ($newhour < 10);
	$newminute = "0$newminute" if ($newminute < 10);
	$newsecond = "0$newsecond" if ($newsecond < 10);
	$saveyear = ($newyear % 100);
	$newyear = $saveyear + 1900;

	$newmonth_num = "0$newmonth" if ($newmonth < 10);
	$newday = "0$newday" if ($newday < 10);
	$saveyear = "0$saveyear" if ($saveyear < 10);
	$newyear = substr($oldyear,1,2);

	$oldestfound = stringtotime("$newmonth_num/$newday/$saveyear $txt{'107'} $newhour:$newminute:$newsecond");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) {
				$openmemgr{$curcat} = 1;
				last;
			}
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) {
			next;
		}
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				while( <FILE> ) {
					$message = $_;
				}
				# get only the last post for this thread.
				fclose(FILE);

				chomp $message;
				if( $message ) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
					$mtime = stringtotime($mdate);
					($dates, $times) = split(/ $txt{'107'} /, $mdate);
					($zhour, $zmin, $zsecond) = split(/\:/, $times);
					($zmonth, $zday, $zyear) = split(/\//, $dates);
					if( $newmonth_num == $zmonth && $newday == $zday && $saveyear == $zyear) {
						$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate];
						++$numfound;
					} else {
						next;
					}
				}
			}
		}
	}
	@messages = sort {$b <=> $a } keys %data;
	if( @messages ) {
		$counter = 1;
	} else {
	}
}

sub Todays {
	$todaydisplay;
	( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	($newsecond,$newminute,$newhour,$newday,$newmonth,$newyear,$wday,$yday,$isdst) = localtime(time + (3600*$timeoffset));
	$newmonth = $newmonth+1;
	$newhour = "0$newhour" if ($newhour < 10);
	$newminute = "0$newminute" if ($newminute < 10);
	$newsecond = "0$newsecond" if ($newsecond < 10);
	$saveyear = ($newyear % 100);
	$newyear = $saveyear + 1900;

	$newmonth_num = "0$newmonth" if ($newmonth < 10);
	$newday = "0$newday" if ($newday < 10);
	$saveyear = "0$saveyear" if ($saveyear < 10);
	$newyear = substr($oldyear,1,2);

	$oldestfound = stringtotime("$newmonth_num/$newday/$saveyear $txt{'107'} $newhour:$newminute:$newsecond");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) {
				$openmemgr{$curcat} = 1;
				last;
			}
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) {
			next;
		}
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			for ($i = 0; $i < @threads; $i++) {
				$pollz = 0;
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				while( <FILE> ) {
					$message = $_;
				}
				# get only the last post for this thread.
				fclose(FILE);

				chomp $message;
				if( $message ) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
					$mtime = stringtotime($mdate);
					($dates, $times) = split(/ $txt{'107'} /, $mdate);
					($zhour, $zmin, $zsecond) = split(/\:/, $times);
					($zmonth, $zday, $zyear) = split(/\//, $dates);
					if( $newmonth_num == $zmonth && $newday == $zday && $saveyear == $zyear) {
						if (-e "$datadir/$tnum.poll") {
							$pollz = 1;
						}
						if (-e "$datadir/$tnum.polll") {
							$pollz = 2;
						}
						if (!-e "$datadir/$tnum.polll" && !-e "$datadir/$tnum.poll") {
							$pollz = 0;
						}

						fopen(FILEZ, "$datadir/$tnum.txt");
						$messages = <FILEZ>;
						fclose(FILEZ);
						($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$messages);

						$mtime = stringtotime($mdate);

						($dates, $times) = split(/ $txt{'107'} /, $mdate);
						($zhour, $zmin, $zsecond) = split(/\:/, $times);
						($zmonth, $zday, $zyear) = split(/\//, $dates);

						$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate, $pollz];
						++$numfound;
					} else {
						next;
					}
				}
			}
		}
	}

	@messages = sort {$b <=> $a } keys %data;
	if( @messages ) {
		if( @messages > $todaydisplay ) {
			$#messages = $todaydisplay - 1;
		}
 		$counter = 1;
		# Load Censor List
		&LoadCensorList;
	} else {
		$yymain .= qq~<hr class="hr"><b>$txt{'170'}</b><hr>~;
	}
	for( $i = 0; $i < @messages; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate, $pollz) = @{ $data{$messages[$i]} };
		if( $tusername ne 'Guest' ) {
			&LoadUser($tusername);
			$tname = exists $userprofile{$tusername} ? $userprofile{$tusername}->[1] : $tname;
			$tname ||= $txt{'470'};
			$tname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tusername}" alt="$txt{'27'}: $musername">$tname</a>~;
		}
		if( $musername ne 'Guest' ) {
			&LoadUser($musername);
			$mname = exists $userprofile{$musername} ? $userprofile{$musername}->[1] : $mname;
			$mname ||= $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" alt="$txt{'27'}: $musername">$mname</a>~;
		}
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
	### hide mod ###
	if( $message =~ /\[hide\]/) { 
		$message =~ s/\[hide\](.+?)\[\/hide\]/\[HIDDEN\]/g; 
	}
	### /hide mod ###
		####
		fopen(MBCO, "$boardsdir/$board.mbo");
		@lines = <MBCO>;
		fclose(MBCO);
		($mbco_passw,$mbco_pic) = split(/\|/, $lines[0]);
		$forboardpw = "$cookiepassword$board";
		$crypass=crypt($mbco_passw,$pwseed);
		if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) {
			$message = $mbco{'13'};
			$msub = $mbco{'14'};
			#$tnum = $mbco{'14'};
			}
		####
		&wrap;
		&wrap2;
		if($enable_notification) {
			$notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum;start=$startnum">$img{'notify'}</a>~;
		}

		if (length($message) > $howlong) {
			$message = substr($message,0,$howlong);
			$message .= qq~<b><i><a href="$scripturl?board=$board;action=display;num=$tnum;start=$c" target="_blank">...</a>~;
		}

		if ($pollz eq 1) {
			$pollimg = qq~   $img{'pollicon'}~;
		} elsif ($pollz eq 2) {
			$pollimg = qq~   $img{'polliconclosed'}~;
		} else {
			$pollimg = qq~~;
		}

		$yymain .= qq~
<table border=0 width=100% cellspacing=1 $color{'bordercolor'}>
  <tr>
    <td align=left bgcolor="$color{'titlebg'}"><font class="text1" color="$color{'titletext'}" size=2>&nbsp;$counter&nbsp;</font></td>
    <td width=75% bgcolor="$color{'titlebg'}"><font class="text1" color="$color{'titletext'}" size=2><b>&nbsp;$catname{$cat{$board}} / $boardinfo{$board}->[0] / <a href="$scripturl?board=$board;action=display;num=$tnum;start=$c"><font class="text1" color="$color{'titletext'}" size=2><u>$msub</u></font></a></b></font>$pollimg</td>
    <td align=right bgcolor="$color{'titlebg'}"><nobr>&nbsp;<font class="text1" color="$color{'titletext'}" size=2>$txt{'30'}: $mdate&nbsp;</font></nobr></td>
  </tr><tr>
    <td colspan=3 bgcolor="$color{'catbg'}" class="catbg"><font class="catbg" size=2>$txt{'109'} $tname | $txt{'22'} $txt{'525'} $mname</font></td>
  </tr><tr>
    <td colspan=3 bgcolor="$color{'windowbg2'}" valign=top><font size=2>$message</font></td>
  </tr><tr>
    <td colspan=3 bgcolor="$color{'catbg'}"><font size=2>&nbsp;
~;
if ($tstate != 1) {
	$yymain .= qq~<a href="$scripturl?board=$board;action=post;num=$tnum;start=$c;title=Post+reply">$img{'reply'}</a>$menusep<a href="$scripturl?board=$board;action=post;num=$tnum;quote=$c;title=Post+reply">$img{'replyquote'}</a>$notify~;
}
$yymain .= qq~
    </font></td>
  </tr>
</table><br>~;
		++$counter;
	}

	$yymain .= qq~<font size="1"><a href="$cgi">$txt{'236'}</a> $txt{'237'}<br></font>~;
	$yytitle = "Today's Posts";
	&template;
	exit;
}

1;